require "config"
-- 3K Config-->>奇天
if PlatformTools.GetPkgResourcePath() == "zxqitian" then
	
	Config.Plat = "http://plat.qt.ffcai.com/"
	Config.Manager = "http://manager.qt.ffcai.com/"
	Config.Cdn = "http://cdn.qt.ffcai.com/"
end
Cdn_url = Config.Cdn
G_CALLBACKFUNC_ID = 0
G_CALLBACKFUNC_LIST = {}

SHORT_TIME_OUT = 10000
LONG_TIME_OUT = 60000

GameLib.AddCallBackFunc = function (func)
	G_CALLBACKFUNC_ID = G_CALLBACKFUNC_ID + 1
	if G_CALLBACKFUNC_LIST[G_CALLBACKFUNC_ID] == nil then
		G_CALLBACKFUNC_LIST[G_CALLBACKFUNC_ID] = func
	end
	return G_CALLBACKFUNC_ID
end

function RunCallBackFunc(func_id, ...)
	if G_CALLBACKFUNC_LIST[func_id] ~= nil then
		G_CALLBACKFUNC_LIST[func_id](...)
	end
end

function DelCallBackFunc(func_id)
	if G_CALLBACKFUNC_LIST[func_id] ~= nil then
		G_CALLBACKFUNC_LIST[func_id] = nil
	end
end

GameLib.PrintLog = function (...)
	local tmp_str = string.format(...)
	GameLib.COCOLog(tmp_str)
end

---显示系统模式框
function ShowSysDlgLayer(title, confirm_text, confirm_fun, cancel_text, cancel_fun)
	local view = GameLayer.Node()
	
	---调整分辨率
	local screen_size = COCOSize()
	GameLib.SceneManager:GetSize(screen_size)
	local ui_scale = screen_size.width / 480
	view:SetScaleFactor(ui_scale)
	local origin_x = screen_size.width / 2
	local origin_y = screen_size.height / 2
	view:SetPosition(origin_x, origin_y)	
	
	local bk_label = Label.CreateWithImageFile("resource/start/tip_bk.png")
	view:AddChild(bk_label)

	local title_label = Label.CreateWithString(title, "HelveticaNeue-Bold", 12)
	title_label:SetPosition(0, 22)
	view:AddChild(title_label)
	
	local confirm_btn = ImageButton.CreateWithImages("resource/start/tip_button.png",
													"resource/start/tip_buttonlight.png",
													"resource/start/tip_buttonlight.png")
	view:AddChild(confirm_btn)
	confirm_btn:SetButtonText(confirm_text, "HelveticaNeue-Bold", 12)
	local OnConfirm = function()
		if(confirm_fun) then
			confirm_fun()
		end
		view:RemoveSelf(true)
	end
	local confirm_callback = GameLib.AddCallBackFunc(OnConfirm)
	confirm_btn:SetLuaTouchUp(confirm_callback)
	confirm_btn:SetPosition(0, -16)
	
	if(cancel_text) then
		cancel_btn = ImageButton.CreateWithImages("resource/start/tip_button.png",
													"resource/start/tip_buttonlight.png",
													"resource/start/tip_buttonlight.png")
		view:AddChild(cancel_btn)
		cancel_btn:SetButtonText(cancel_text, "HelveticaNeue-Bold", 12)
		local OnCancel = function()
			if(cancel_fun) then
				cancel_fun()
			end	
			view:RemoveSelf(true)
		end
		local cancel_callback = GameLib.AddCallBackFunc(OnCancel)
		cancel_btn:SetLuaTouchUp(cancel_callback)
		confirm_btn:SetPosition(-36, -16)
		cancel_btn:SetPosition(36, -16)
	end
	
	view:SetScaleFactor(0.2)
	ActionManager.ScaleTo(view, 0.25, ui_scale)
	GameLib.SceneManager:GetRunningScene():AddLayer(view, 2, 2)
end

local error_box_show = false
local retry_fun_list = {}

function NetWorkErrorFun(retry_fun, ret_code, error_log)
	retry_fun_list[#retry_fun_list + 1] = retry_fun
	
	if(error_box_show) then
		return
	end

	local ErrorCallFun = function()
		for _, v in pairs(retry_fun_list) do
			v()
		end
		
		retry_fun_list = {}
		error_box_show = false
	end
	
	error_log = error_log or "网络连接失败，请检查网络，请重试"
	error_log = error_log.."[%d]"
	local error_str = string.format(error_log, ret_code)
	ShowSysDlgLayer(error_str, "确定", ErrorCallFun)
	error_box_show = true
end

function CheckNetWorkFun(enter_fun)
	if(PlatformTools.GetNetWorkConnectingState("www.baidu.com") ~= PlatformTools.NETWORK_WIFI) then
		ShowSysDlgLayer("当前未打开wifi,是否将使用移动网络?", "使用", enter_fun, "取消")
	else
		enter_fun()
	end
end

---检查版本完成，根据缓存判断进入游戏主城or注册登录界面
function GotoGame()
	Init()
	Start()
end

---更新start自身lua文件
function UpdateStartLua()
	local loaded_file_num = 0
	local filelist = {
		"resource/start.lua",
	}

	---完成读取一个资源文件
	local OnFileLoaded = function (funcid, ret_code, file_name, file_len)
		--读取失败
		if(ret_code ~= 0) then
			local func = function()
				GameLib.ResManager:UpdateFileList({file_name}, 1, funcid, 2 * SHORT_TIME_OUT)
			end
			NetWorkErrorFun(func, ret_code, "网络不给力,请重试(4)")
			return
		end

		loaded_file_num = loaded_file_num + 1
		---全部start lua文件读取完成
		if loaded_file_num == #filelist then
			DelCallBackFunc(funcid)
			package.loaded["start"] = nil
			require "start"
			UpdateMyRes()
		end
	end
	-- 更新本场景文件版本并进行重新加载
	local update_res_funcid = GameLib.AddCallBackFunc(OnFileLoaded)
	if(GameLib.ResManager:UpdateFileList(filelist, #filelist, update_res_funcid, 2 * SHORT_TIME_OUT) == false) then
		GameLib.PrintLog("Loading 远程start lua 文件读取失败")
	end
end
--获取包名
function GetPkgName()
	local start_index
	local end_index
	local pkgname_fromid = PlatformTools.GetPkgNameAndFromId()
	start_index,end_index = string.find(pkgname_fromid,"|")
	return string.sub(pkgname_fromid,1,start_index-1)
end

--获取fromid
function GetFromId()
	local start_index
	local end_index
	local pkgname_fromid = PlatformTools.GetPkgNameAndFromId()
	start_index,end_index = string.find(pkgname_fromid,"|")
	
	local temp_fromid = "0"
	if (end_index < string.len(pkgname_fromid)) then
		temp_fromid = string.sub(pkgname_fromid,end_index+1,string.len(pkgname_fromid))
	end
	return temp_fromid
end

function UpdateSdkRes(filelist)
		-- 特殊平台资源处理
	local plat_name = PlatformTools.GetPkgResourcePath()
	
	
	if (plat_name == "ydn") then
		table.insert(filelist, "resource/3rdplat/ydn/ddle_logo.png")
	elseif (plat_name == "downjoy") then
		table.insert(filelist, "resource/3rdplat/downjoy/sdk_logo.png")
	elseif (plat_name == "zxqitian") then
		local pkg_name = GetPkgName()
		if (pkg_name == "com.kuyue.zxqitian3") then
			table.insert(filelist, "resource/start/3rdplat/zxqitian/background_zxqitian3.jpg")
		elseif (pkg_name == "com.kuyue.zxqitian4") then
			table.insert(filelist, "resource/start/3rdplat/zxqitian/background_zxqitian4.jpg")
		else
			table.insert(filelist, "resource/start/3rdplat/zxqitian/background_zxqitian.jpg")
		end
		
	elseif (plat_name == "zx5gwan") then
		
		local pkg_name = GetPkgName()
		if (pkg_name == "com.kuyue.zx5gwan1") then
			table.insert(filelist, "resource/start/3rdplat/zx5gwan/background_zx5gwan1.jpg")
		elseif (pkg_name == "com.kuyue.zx5gwan2") then
			table.insert(filelist, "resource/start/3rdplat/zx5gwan/background_zx5gwan2.jpg")
		else
			table.insert(filelist, "resource/start/3rdplat/zx5gwan/background_zx5gwan.jpg")
		end
		
	elseif (plat_name == "zx49you") then
		table.insert(filelist, "resource/start/3rdplat/zx49you/background_zx49you.jpg")
	end
end

---更新start自身资源
function UpdateMyRes()
	local loaded_file_num = 0
	local filelist = {
		--start自身资源
		"resource/start/background.jpg",
		"resource/start/check_version.png",
		"resource/start/check.png",		
		"resource/start/tip_bk.png",
		"resource/start/tip_button.png",
		"resource/start/tip_buttonlight.png",

		"resource/load_resource/bg.jpg",
		"resource/load_resource/entergame.png",
		"resource/load_resource/entergamelight.png",
		"resource/load_resource/entergameimmediate.png",
		"resource/load_resource/entergameimmediatelight.png",
		"resource/load_resource/light.png",
		"resource/load_resource/bar1.png",
		"resource/load_resource/bar2.png",
		"resource/load_resource/tipskuang.png",
		"resource/load_resource/tipsword.png",
		"resource/load_resource/worddisplaybk.png",
		"resource/load_resource/wordbutton2.png",
		"resource/load_resource/wordbutton2light.png",		
			
		"resource/load/bar1.png",
		"resource/load/bar2.png",
		"resource/load/bg.jpg",
		"resource/load/light.png",
	
		"resource/effects/e510.sdz",
		"resource/config/effects/e510.cnf",
	}
	-- 特殊平台资源处理
	UpdateSdkRes(filelist)

	---完成读取一个资源文件
	local OnFileLoaded = function (funcid, ret_code, file_name, file_len)
		--读取失败
		if(ret_code ~= 0) then
			local func = function()
				GameLib.PrintLog(file_name.."更新失败,重试")
				GameLib.ResManager:UpdateFileList({file_name}, 1, funcid, LONG_TIME_OUT)
			end
			NetWorkErrorFun(func, ret_code, "网络不给力,请重试(3)")
			return
		end

		loaded_file_num = loaded_file_num + 1
		---全部资源文件读取完成
		if loaded_file_num == #filelist then
			DelCallBackFunc(funcid)
			Init(true)
		end
	end

	-- 更新本场景文件版本并进行重新加载
	local update_res_funcid = GameLib.AddCallBackFunc(OnFileLoaded)
	if(GameLib.ResManager:UpdateFileList(filelist, #filelist, update_res_funcid, LONG_TIME_OUT) == false) then
		GameLib.PrintLog("Loading 远程start资源文件读取失败")
	end
end

---更新版本文件
function UpdateVersion()
	local OnGetRemoteVersionFileComplete = function(funcid, ret_code, file_name, file_len)
		if ret_code ~= 0 then
			local func = function()
				GameLib.PrintLog("远程版本文件下载失败,重试")
				GameLib.ResManager:CheckVersionFile(funcid, LONG_TIME_OUT)
			end
			NetWorkErrorFun(func, ret_code, "网络不给力,请重试(2)")
			return

		else
			DelCallBackFunc(funcid)
			UpdateStartLua()
		end
	end

	local md5_retry_count = 0
	local OnGetRemoteVersionMd5 = function(funcid, ret_code, file_name, file_len)
		if ret_code ~= 0 then
			local func = function()
				GameLib.PrintLog("远程版本md5文件下载失败,重试")
				GameLib.ResManager:CheckVersionMd5(funcid, SHORT_TIME_OUT)
			end
			
			if(md5_retry_count > 0) then
				NetWorkErrorFun(func, ret_code, "网络不给力,请重试(1)")
			else
				md5_retry_count = md5_retry_count + 1
				func()
			end
			return
		end
		
		DelCallBackFunc(funcid)
		
		--版本文件无改变
		local local_version_md5 = string.sub(GameLib.ResManager:GetLocalVersionMd5(), 1, 32)
		local remote_version_md5 = string.sub(GameLib.ResManager:GetDownloadVersionMd5(), 1, 32)
		GameLib.PrintLog("local version:"..local_version_md5)
		GameLib.PrintLog("remote version:"..remote_version_md5)
		if(local_version_md5 == remote_version_md5) then
			GameLib.ResManager:ReadRemoteVersionFile()
			UpdateStartLua()
		else
			GameLib.PrintLog("dwonload remote version")
			--更新版本文件
			local check_version_func_id = GameLib.AddCallBackFunc(OnGetRemoteVersionFileComplete)
			if not GameLib.ResManager:CheckVersionFile(check_version_func_id, LONG_TIME_OUT) then
				DelCallBackFunc(check_version_func_id)
			end
		end
	end
	
	--获取远程md5码
	local check_md5_func_id = GameLib.AddCallBackFunc(OnGetRemoteVersionMd5)
	if not GameLib.ResManager:CheckVersionMd5(check_md5_func_id, SHORT_TIME_OUT) then
		DelCallBackFunc(check_md5_func_id)
	end
end

---更新脚本文件
function UpdateScript()
	local filelist = {
		"resource/script0.ios",
		"resource/script1.ios",
		"resource/script2.ios",
		"resource/script3.ios",
		"resource/script4.ios",
		"resource/script5.ios",
		"resource/script6.ios",
		"resource/script7.ios",
		"resource/script8.ios",
		"resource/script9.ios",
		"resource/script10.ios",
	}
	local loaded_file_num = 0
	
	---完成读取一个资源文件
	local OnFileLoaded = function (funcid, ret_code, file_name, file_len)
		--读取失败
		if(ret_code ~= 0) then
			local func = function()
				GameLib.PrintLog("load script failed")
				GameLib.ResManager:UpdateFileList({file_name}, 1, funcid, 5 * LONG_TIME_OUT)
				g_progress_val = 0
				g_update_progress = true
			end
			NetWorkErrorFun(func, ret_code, "下载运行文件失败，重试?")
			g_update_progress = false
			return
		end
		
		--全部script文件读取完进入游戏
		loaded_file_num = loaded_file_num + 1
		if(loaded_file_num == #filelist) then
			DelCallBackFunc(funcid)
			g_loading_progress:SetString("检查更新完毕，进入游戏")
			package.loaded["start"] = nil
			GameLib.PrintLog("loading script success")
			GameLib.ResManager:SetScriptPackageList(filelist)
			GameLib.LuaEngine:RegistPackageLoad()
			require "main"
			GotoGame()
		end
	end

	-- 更新本场景文件版本并进行重新加载
	local update_res_funcid = GameLib.AddCallBackFunc(OnFileLoaded)
	if(GameLib.ResManager:UpdateFileList(filelist, #filelist, update_res_funcid, 5 * LONG_TIME_OUT) == false) then
		GameLib.PrintLog("Loading 远程脚本文件读取失败")
	end
	
	g_loadingtext:SetVisible(false)
	g_loading_progress:SetVisible(true)
	g_update_progress = true
	g_progress_val = 0
end

g_loadingtext = nil
g_loading_progress = nil
g_progress_val = 0
g_update_progress = false


function GetBackgroundImagePath()
	-- 某些sdk更换背景
	-- 特殊平台资源处理
	local bg
	local plat_name = PlatformTools.GetPkgResourcePath()

	bg = "resource/start/3rdplat/"..plat_name.."/"
	
	if (plat_name == "zxqitian") then
		
		local pkg_name = GetPkgName()
		if (pkg_name == "com.kuyue.zxqitian3") then
			bg = bg.."background_zxqitian3.jpg"
		elseif (pkg_name == "com.kuyue.zxqitian4") then
			bg = bg.."background_zxqitian4.jpg"
		else
			bg = bg.."background_zxqitian.jpg"
		end
		
	elseif (plat_name == "zx5gwan") then
		local pkg_name = GetPkgName()
		if (pkg_name == "com.kuyue.zx5gwan1") then
			bg = bg.."background_zx5gwan1.jpg"
		elseif (pkg_name == "com.kuyue.zx5gwan2") then
			bg = bg.."background_zx5gwan2.jpg"
		else
			bg = bg.."background_zx5gwan.jpg"
		end
		
	elseif (plat_name == "zx49you") then
		bg = bg.."background_zx49you.jpg"
		
	else
		bg = "resource/start/background.jpg"
	end
	return bg
end

function CreateUI(scene, again)
	--界面
	local screen_size = COCOSize()
	GameLib.SceneManager:GetSize(screen_size)

	local layer = GameLayer.Node()

	local scale_size = GameLib.SceneManager:GetScaleSize()
	local width_scale = screen_size.width * scale_size / 960
	local height_scale = screen_size.height * scale_size / 640
	local scale_factor
	if(width_scale > height_scale) then
		scale_factor = width_scale
	else
		scale_factor = height_scale
	end
	
	layer:SetScaleFactor(scale_factor)
	scene:AddLayer(layer, 1, 1)
	local bg
	if(again) then
		bg = Label.CreateWithImageFile(GetBackgroundImagePath())
		GameLib.PrintLog("start again")
	else	
		bg = Label.CreateWithImageFile("resource/start/background.jpg")		
	end	
	layer:AddChild(bg, 0, 0)

	g_loadingtext = Label.CreateWithImageFile("resource/start/check_version.png")
	g_loadingtext:SetPosition(0, -128 * height_scale / scale_factor)
	layer:AddChild(g_loadingtext, 0, 0)
	
	g_loading_progress = Label.CreateWithString(string.format("正在更新游戏数据...0%%"), "HelveticaNeue-Bold", 10)
	g_loading_progress:SetPosition(0, -128 * height_scale / scale_factor)
	g_loading_progress:SetColor(36, 36, 36)
	g_loading_progress:SetStroke(true)
	g_loading_progress:SetVisible(false)
	layer:AddChild(g_loading_progress, 0, 0)	

	local loading_sprite = ImageSprite.CreateWithImage("resource/start/check.png", 1, 12, 1/12)
	loading_sprite:SetSpriteState(1)
	loading_sprite:SetPosition(0, -96 * height_scale / scale_factor)
	layer:AddChild(loading_sprite)
	layer:SetPosition(screen_size.width/2,screen_size.height/2)

	--响应key返回按钮
	GameLib.SceneManager:SetKeypadEnabled(true)
	local OnBackKey = function ()
			
		local certain_fun = function()
			GameLib.GameEngine:CloseApp()
		end
		local certain_fun_id = GameLib.AddCallBackFunc(certain_fun)
		
		if (PlatformTools.GetPkgResourcePath() == "91s") then
			--让91社区捕获到返回按钮事件
			PlatformTools.SendGameStatus("ExitGame", "是否确认退出游戏?")
		else
			PlatformTools.ShowDialog("提示", "是否确认退出游戏?", "确定", "取消", certain_fun_id, 0)
		end
		
	end
	local back_fun_id = GameLib.AddCallBackFunc(OnBackKey)
	GameLib.SceneManager:SetLuaBackKey(back_fun_id)
end

function Init(again)
	local scene

	if(again) then
		--运行新的start之前先检查自身版本
		if (GameLib.ResManager:HasNewCppVersion()) then
			local CheckNewVersion
			CheckNewVersion = function()
				local download_url = Cdn_url.."download/index.php?type="..GameLib.ResManager:GetSystemType().."&rnd="..math.mod(GameLib.Rand(), 1000)
				--if (PlatformTools.GetPkgResourcePath() == "kkk5") then
				--	download_url = download_url.."&uid="..tostring(GameLib.ResManager:GetSetting("ThirdUid"))
				--end
			
				local start_index
				local end_index
			
				local pkgname_fromid
				--- 安智特殊处理
				if (PlatformTools.GetPkgResourcePath() == "Anzhi") then
					pkgname_fromid = "com.kuyue.anzhipay|"
				else
					pkgname_fromid = PlatformTools.GetPkgNameAndFromId()
				end
				start_index,end_index = string.find(pkgname_fromid,"|")
				local temp_pkgname = string.sub(pkgname_fromid,1,start_index-1)
			
				local temp_fromid = "0"
				if (end_index < string.len(pkgname_fromid)) then
					temp_fromid = string.sub(pkgname_fromid,end_index+1,string.len(pkgname_fromid))
				end
			
				download_url = download_url.."&pkgname="..temp_pkgname.."&fromid="..temp_fromid
				GameLib.PrintLog("down url: %s", download_url)
				
				PlatformTools.GoToBrowser(download_url)
				ShowSysDlgLayer("检测到新的游戏版本，将自动更新", "确定", CheckNewVersion)
			end
		
			if (PlatformTools.GetPkgResourcePath() ~= "91s") then
				ShowSysDlgLayer("检测到新的游戏版本，将自动更新", "确定", CheckNewVersion)
				return
			else
				CheckNewVersion = function()
					ShowSysDlgLayer("新版本正在上架,请稍后", "确定", CheckNewVersion)
				end
				CheckNewVersion()
				return
			end
		end
		---49app强制更新版本判断
		if(PlatformTools.GetPkgResourcePath() == "zx49you" and
			PlatformTools.GetSDKUserCenterImagePath() ~= "") then
			--调用更新接口强制更新49游的版本
			local CheckNewVersion
			CheckNewVersion = function()
				local download_url = Cdn_url.."download/index.php?type="..GameLib.ResManager:GetSystemType().."&rnd="..math.mod(GameLib.Rand(), 1000)
				
				download_url = download_url.."&pkgname="..GetPkgName().."&fromid="..GetFromId()
				GameLib.PrintLog("down url: %s", download_url)
				
				PlatformTools.GoToBrowser(download_url)
				ShowSysDlgLayer("检测到新的游戏版本，将自动更新", "确定", CheckNewVersion)
			end
			ShowSysDlgLayer("检测到新的游戏版本，将自动更新", "确定", CheckNewVersion)
			return
		end

		scene = global_scene
		scene:RemoveLayer(1, true)
		CreateUI(scene, again)
		global_scene = nil
		run_check_network_fun = true
		run_check_network_delay = 0
	else
		scene = GameScene.Node()
		GameLib.ResManager:SetPlatAndResURL("", Cdn_url)
		GameLib.SceneManager:RunWithScene(scene)
		global_scene = scene
		CreateUI(scene, again)
		---更新版本文件和自身资源
		UpdateVersion()
	end
end

g_interval = 0.0
function Update(interval)
	g_interval = g_interval + interval
	if(g_update_progress) then
		if(g_progress_val < 10) then
			g_progress_val = g_progress_val + interval * math.random(50, 150) / 100
		else
			g_progress_val = g_progress_val + interval * math.random(10, 60) / 100
		end
	end
	
	if(g_interval > 0.5) then
		if(g_progress_val > 99) then
			g_progress_val = 99
		end
		if(g_loading_progress) then
			g_loading_progress:SetString(string.format("正在更新游戏数据...%d%%", g_progress_val))
		end
		g_interval = 0.0
	end
	
	--延迟，至少0.5秒显示平台图片
	if(run_check_network_fun) then
		run_check_network_delay = run_check_network_delay + interval
	
		if(run_check_network_delay > 0.5) then
			run_check_network_fun = false
			---检查网络状态 并更新脚本文件
			CheckNetWorkFun(UpdateScript)
		end
	end
end

-- 收到服务器消息
function OnRecv(netid)
	GameLib.PrintLog("not allow OnRecv")
end

-- 网络断开
function OnDisconnect(netid)
	GameLib.PrintLog("not allow OnDisconnect")
end

-- 连接成功
function OnConnect(result, handle, netid, ip, port)
	GameLib.PrintLog("not allow OnConnect")
end
